/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.tables.records.VRestValuelistRecord;

import java.util.Collection;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.JSONB;
import org.jooq.Name;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class VRestValuelist extends TableImpl<VRestValuelistRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.v_rest_valuelist</code>
     */
    public static final VRestValuelist V_REST_VALUELIST = new VRestValuelist();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<VRestValuelistRecord> getRecordType() {
        return VRestValuelistRecord.class;
    }

    /**
     * The column <code>common_dd.v_rest_valuelist.list_id</code>.
     */
    public final TableField<VRestValuelistRecord, Integer> LIST_ID = createField(DSL.name("list_id"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_rest_valuelist.valuelist</code>.
     */
    public final TableField<VRestValuelistRecord, String> VALUELIST = createField(DSL.name("valuelist"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_rest_valuelist.locale</code>.
     */
    public final TableField<VRestValuelistRecord, String> LOCALE = createField(DSL.name("locale"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_rest_valuelist.variables</code>.
     */
    public final TableField<VRestValuelistRecord, JSONB> VARIABLES = createField(DSL.name("variables"), SQLDataType.JSONB, this, "");

    private VRestValuelist(Name alias, Table<VRestValuelistRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private VRestValuelist(Name alias, Table<VRestValuelistRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.view("""
        create view "v_rest_valuelist" as  WITH y(l, c, i) AS (
                WITH x(l, v, i, t, o) AS (
                        SELECT v_1.fk_value_valuelist,
                           v_1.varvalue,
                           t.isocode,
                           t.value AS lang_value,
                           v_1.value_order
                          FROM ((common_dd.t_core_value v_1
                            LEFT JOIN common_dd.t_core_valueparam vp ON ((vp.fk_valueparam_value = v_1.pk_core_value)))
                            LEFT JOIN common_dd.t_core_translation t ON ((t.fk_trans_key = vp.param_key)))
                       )
                SELECT x.l,
                   string_agg(((x.v || '='::text) || x.t), '|'::text ORDER BY x.o) AS string_agg,
                   x.i
                  FROM x
                 GROUP BY x.l, x.i
               )
        SELECT y.l AS list_id,
           y.c AS valuelist,
           (y.i)::text AS locale,
           jsonb_agg(e.unique_name) AS variables
          FROM ((y
            LEFT JOIN common_dd.t_core_variable v ON ((v.fk_var_valuelist = y.l)))
            LEFT JOIN common_dd.t_core_element_hierarchy e ON ((e.key_element = v.key_variable)))
         GROUP BY y.l, y.c, y.i;
        """), where);
    }

    /**
     * Create an aliased <code>common_dd.v_rest_valuelist</code> table reference
     */
    public VRestValuelist(String alias) {
        this(DSL.name(alias), V_REST_VALUELIST);
    }

    /**
     * Create an aliased <code>common_dd.v_rest_valuelist</code> table reference
     */
    public VRestValuelist(Name alias) {
        this(alias, V_REST_VALUELIST);
    }

    /**
     * Create a <code>common_dd.v_rest_valuelist</code> table reference
     */
    public VRestValuelist() {
        this(DSL.name("v_rest_valuelist"), null);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public VRestValuelist as(String alias) {
        return new VRestValuelist(DSL.name(alias), this);
    }

    @Override
    public VRestValuelist as(Name alias) {
        return new VRestValuelist(alias, this);
    }

    @Override
    public VRestValuelist as(Table<?> alias) {
        return new VRestValuelist(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public VRestValuelist rename(String name) {
        return new VRestValuelist(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public VRestValuelist rename(Name name) {
        return new VRestValuelist(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public VRestValuelist rename(Table<?> name) {
        return new VRestValuelist(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VRestValuelist where(Condition condition) {
        return new VRestValuelist(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VRestValuelist where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VRestValuelist where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VRestValuelist where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VRestValuelist where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VRestValuelist where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VRestValuelist where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VRestValuelist where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VRestValuelist whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VRestValuelist whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
